with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.IHTMLObjectElement3_Interface is

   procedure Initialize (This : in out IHTMLObjectElement3_Type) is
   begin
      Set_IID (This, IID_IHTMLObjectElement3);
   end Initialize;

   function Pointer (This : IHTMLObjectElement3_Type)
     return Pointer_To_IHTMLObjectElement3
   is
   begin
      return To_Pointer_To_IHTMLObjectElement3 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLObjectElement3_Type;
                     Pointer : in     Pointer_To_IHTMLObjectElement3)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_archive
     (This : IHTMLObjectElement3_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_archive
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_archive;

   function Get_archive
     (This : IHTMLObjectElement3_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_archive
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_archive;

   procedure Put_alt
     (This : IHTMLObjectElement3_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_alt
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_alt;

   function Get_alt
     (This : IHTMLObjectElement3_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_alt
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_alt;

   procedure Put_declare
     (This : IHTMLObjectElement3_Type;
      p    : GNATCOM.Types.VARIANT_BOOL)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_declare
         (Pointer (This),
          p));

   end Put_declare;

   function Get_declare
     (This : IHTMLObjectElement3_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_declare
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_declare;

   procedure Put_standby
     (This : IHTMLObjectElement3_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_standby
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_standby;

   function Get_standby
     (This : IHTMLObjectElement3_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_standby
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_standby;

   procedure Put_border
     (This : IHTMLObjectElement3_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_border
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_border;

   function Get_border
     (This : IHTMLObjectElement3_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_border
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_border;

   procedure Put_useMap
     (This : IHTMLObjectElement3_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_useMap
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_useMap;

   function Get_useMap
     (This : IHTMLObjectElement3_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_useMap
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_useMap;

end MSHTML.IHTMLObjectElement3_Interface;

